#include "StdAfx.h"
#include "SMSDialogManager.h"
#include "SMSSendWnd.h"

SMSDialogManager::SMSDialogManager(void)
: m_nReceiverMaxCount(50)
{
}
SMSDialogManager::~SMSDialogManager(void)
{
}


void SMSDialogManager::SetReadOnly( BOOL bStatus, CObject* pObject )
{
	CSMSSendDlg* pDialog = (CSMSSendDlg*) pObject;
}
void SMSDialogManager::Create( const std::vector<CSMSModel::SMSReceiverInfo>& receiverVector, CWnd* pParent)
{	


	/*CSMSSendDlg* pDialog = new CSMSSendDlg();
	if (NULL == pDialog)
		return;

	pDialog->Create(receiverVector, CSMSSendDlg::IDD, CWnd::GetDesktopWindow());
	pDialog->ShowWindow(SW_SHOW);*/

	/**/

	
	CSMSSendWnd* pSmsWnd = new CSMSSendWnd(pParent,receiverVector);

	if (!pSmsWnd)
		return ;

	CPoint pt(0, 0);
	RECT rcClient = { 0 };;
	GetWindowRect(pParent->GetSafeHwnd(), &rcClient);

	//pSmsWnd->Create(NULL, _T("SMSSendWnd"), WS_POPUP, 0, NULL);
	pSmsWnd->Create(NULL,LoadStringFromResource(IDS_STRING293), WS_POPUP, 0, NULL);
	
//	pSmsWnd->Create(pParent );

	m_listDialog.AddTail((CObject*)pSmsWnd);
}

void SMSDialogManager::CreateBuddyLIstSMS( const std::vector<const IGTBuddyUser*>& buddyVector , CWnd* pParent)
{
	std::vector<CSMSModel::SMSReceiverInfo> receiverVector;
	CSMSModel::SMSReceiverInfo receiverInfo;

	std::vector<const IGTBuddyUser* >::const_iterator buddyIterator = buddyVector.begin();
	for (; buddyIterator != buddyVector.end(); ++buddyIterator)
	{
		const IGTBuddyUser* pUser = *buddyIterator;
		receiverInfo.strID = pUser->GetUserID();
		receiverInfo.strName = pUser->GetName();
		const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(pUser->GetUserID());
		if (data)
		{
			receiverInfo.strCellPhone =  data->strCellPhone.c_str();
			receiverVector.push_back(receiverInfo);
		}
	}

	Create(receiverVector, pParent);
}


void SMSDialogManager::CreateListSMS( const std::vector<CSMSModel::SMSReceiverInfo>& receiverVector, CWnd* pParent )
{
	Create(receiverVector, pParent);
}

void SMSDialogManager::CreateMemberListSMS( const NE_MEMBER_DATA_LIST& list, CWnd* pParent )
{
	std::vector<CSMSModel::SMSReceiverInfo> receiverVector;
	CSMSModel::SMSReceiverInfo receiverInfo;
	for(size_t i = 0; i < list.nSize; i++)
	{
		const NE_MEMBER_DATA &sMemberInfo = list.pList[i];
		receiverInfo.strID = sMemberInfo.strUserId.c_str();
		receiverInfo.strName = sMemberInfo.strName.c_str();
		receiverInfo.strCellPhone = sMemberInfo.strCellPhone.c_str();
		receiverVector.push_back(receiverInfo);
	}
	Create(receiverVector, pParent);

}

void SMSDialogManager::CreateMemberSms(const std::vector<NE_MEMBER_DATA>& memberVector, CWnd* pParent /* = AfxGetMainWnd */)
{
    std::vector<CSMSModel::SMSReceiverInfo> receiverVector;
    CSMSModel::SMSReceiverInfo receiverInfo;
    for(std::vector<NE_MEMBER_DATA>::const_iterator iter = memberVector.begin();
        iter != memberVector.end(); 
        ++iter)
    {
        const NE_MEMBER_DATA &sMemberInfo = *iter;
        receiverInfo.strID = sMemberInfo.strUserId.c_str();
        receiverInfo.strName = sMemberInfo.strName.c_str();
        receiverInfo.strCellPhone = sMemberInfo.strCellPhone.c_str();
        receiverVector.push_back(receiverInfo);
    }
    Create(receiverVector, pParent);
}

void SMSDialogManager::SetViewLanguagePack()
{
	/*for(POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CSMSSendDlg* pDialog =  (CSMSSendDlg*)m_listDialog.GetNext(pos);
		if(pDialog->GetSafeHwnd())
		{
			pDialog->__ResourceLoad();
		}
	}*/
}

int SMSDialogManager::RemoveAll()
{
	CSingleLock removeLock(&m_csDialogRemove);
	removeLock.Lock();

	for (POSITION pos = m_listDialog.GetHeadPosition(); pos != NULL;)
	{
		CSMSSendWnd *pDlg = (CSMSSendWnd*)m_listDialog.GetNext(pos);
		if( pDlg != NULL && pDlg->GetHWND() )
			DestroyWindow(pDlg->GetHWND());
	}

	m_listDialog.RemoveAll();

	removeLock.Unlock();
	return 0;
}
